#include "input/Button.h"

Button::Button() : downTime(0), upTime(0) {
}

void Button::press() {
    downTime = 1;
    upTime = 0;
}

void Button::release() {
    downTime = 0;
    upTime = 1;
}

void Button::tick() {
    downTime += isDown();
    upTime += isUp();
}

bool Button::isDown() const {
    return downTime > 0;
}

int Button::getDownTime() const {
    return downTime;
}

bool Button::isUp() const {
    return upTime > 0;
}

int Button::getUpTime() const {
    return upTime;
}