#include <iostream>

#include "rendering/FileTexture.h"
#include "utils/PNGReader.h"

FileTexture::FileTexture(const char* path) {
    PNGReader reader(path);
    if(reader.hasError()) {
        return;
    }
    std::cout << reader.getChannels() << "\n";
    char* buffer = new char[reader.getBufferSize()];
    if(reader.readData(buffer)) {
        delete[] buffer;
        return;
    }
    texture.setColors(reader.getWidth(), reader.getHeight(), buffer, reader.getChannels());
    for(int i = 0; i < reader.getWidth() * reader.getHeight(); i++) {
        std::cout << (int) buffer[i] << "\n";
    }
    delete[] buffer;
}

void FileTexture::bind() const {
    texture.bind();
}