#ifndef WINDOW_H
#define WINDOW_H

#include <GL/glew.h>
#include <GLFW/glfw3.h>

#include "rendering/WindowSize.h"
#include "rendering/Options.h"

class Window final {
    GLFWwindow* window;
    WindowSize& size;

public:
    Window(WindowSize& size, const Options& options);
    ~Window();

    Window(const Window&) = delete;
    Window& operator=(const Window&) = delete;
    Window(Window&&) = delete;
    Window& operator=(Window&&) = delete;

    bool hasError() const;
    void show();
    bool shouldClose() const;
    void swapBuffers();

    void setKeyCallback(GLFWkeyfun f);
};

#endif