#ifndef ARRAY_H
#define ARRAY_H

template<typename T, int N>
class Array final {
    T data[N];

public:
    Array() = default;

    Array(const T& t) {
        for(int i = 0; i < N; i++) {
            data[i] = t;
        }
    }

    const T& operator[](int index) const {
        return data[index];
    }

    T& operator[](int index) {
        return data[index];
    }

    const T* operator+(int index) const {
        return data + index;
    }

    T* operator+(int index) {
        return data + index;
    }

    T* begin() {
        return data;
    }

    const T* begin() const {
        return data;
    }

    T* end() {
        return data + N;
    }

    const T* end() const {
        return data + N;
    }

    int getLength() const {
        return N;
    }
};

#endif